// -*- Mode: javascript; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2; moz-jssh-buffer-globalobj: "Components.classes['@mozilla.org/moz/jsloader;1'].getService(Components.interfaces.mozIJSComponentLib).probeComponent('rel:smiley.js')" -*-
// smiley.js
// sample implementation of simple xhtml-compatible tag in xtf


debug("*** loading ssn.js \n");


function showError( control )
{
  //set control's background color to red to signal that an error was found
  //  in that control's value

//  control.style.background = this._warningColor;
  control.style.background = 'red';
}

function showValid( control )
{
  //set control's background color to red to signal that an error was found
  //  in that control's value

  control.style.background = '';
}

function validateField( widget )
{
  if( widget )
  {
    var val = widget.value;
    if( val )
    {
      var valid="0123456789";

      if( widget.getAttribute("maxlength") > val.length )
      {
        showError( widget );
        return;
      }

      //make sure that only digits 0-9 are in the input field
      for( var i=0; i<val.length; i++ )
      {
        if( valid.indexOf( val.substr(i,1) ) < 0 )
        {
          //oops, hit a non-numeric value.  Bomb out.
          showError( widget );
          return;
        }
      }

      // Nothing wrong with it.  Call this in case it was previously invalid.
      showValid( widget );
    }
  }
}



//----------------------------------------------------------------------
// ssnElement

function ssnElement() {}

ssnElement.prototype = {

  //----------------------------------------
  // nsISupports methods:

  QueryInterface : function(iid) {
    if (iid.equals(Components.interfaces.nsISupports) ||
        iid.equals(Components.interfaces.nsIXTFXMLVisual) ||
        iid.equals(Components.interfaces.nsIXTFElement) ||
        iid.equals(Components.interfaces.nsIXTFVisual))
      return this;
    throw Components.results.NS_ERROR_NO_INTERFACE;
  },

  //----------------------------------------
  // nsIXTFXMLVisual methods:
  
  onCreated : function(wrapper) {
    this._wrapper = wrapper;
    this._focusoutListener = this.runValidation;

    // build visual content:
    var builder = Components.classes["@mozilla.org/xtf/xml-contentbuilder;1"].createInstance(Components.interfaces.nsIXMLContentBuilder);
    builder.setDocument(this._wrapper.elementNode.ownerDocument);
    builder.setElementNamespace("http://www.w3.org/1999/xhtml");
    builder.beginElement("span");
    this._control = builder.current;
      builder.beginElement("input");
        builder.attrib("maxlength", "3");
        builder.attrib("size", "3");
        this._field1 = builder.current;
      builder.endElement();
      builder.textNode(" - ");
      builder.beginElement("input");
        builder.attrib("maxlength", "2");
        builder.attrib("size", "2");
        this._field2 = builder.current;
      builder.endElement();
      builder.textNode(" - ");
      builder.beginElement("input");
        builder.attrib("size", "4");
        builder.attrib("maxlength", "4");
        this._field3 = builder.current;
      builder.endElement();
    builder.endElement();   // div end

    delete builder;

    // set up event listener:
    var instance = this;
    this._field1.addEventListener("change", this._focusoutListener, false);
    this._field2.addEventListener("change", this._focusoutListener, false);
    this._field3.addEventListener("change", this._focusoutListener, false);

    this._wrapper.notificationMask = 
                Components.interfaces.nsIXTFElement.NOTIFY_ATTRIBUTE_SET |       
                Components.interfaces.nsIXTFElement.NOTIFY_ATTRIBUTE_REMOVED;  
   },

  //----------------------------------------
  // nsIXTFElement methods:
  
  onDestroyed : function() {
    this._field1.removeEventListener("change", this._focusoutListener, false);
    this._field2.removeEventListener("change", this._focusoutListener, false);
    this._field3.removeEventListener("change", this._focusoutListener, false);
    delete this.field1;
    delete this.field2;
    delete this.field3;
    delete this._control;
    delete this._wrapper;
    dump("ssnElement "+this+" destroyed\n");
  },
  
  get elementType() { return Components.interfaces.nsIXTFElement.ELEMENT_TYPE_XML_VISUAL; },

  get isAttributeHandler() { return false; },

  getScriptingInterfaces : function(count) { count = 0; return []; },

  attributeSet : function( nameAtom, value )
  {
    var name = nameAtom.toString();
    if( name == "warningColor" )
    {
      this._warningColor = value;
    }
  },

  attributeRemoved : function( nameAtom )
  {
    var name = nameAtom.toString();
    if( name == "warningColor" )
    {
      this._warningColor = "";
    }
  },

  //----------------------------------------
  // nsIXTFVisual methods:
  
  get visualContent() { return this._control; },

  get insertionPoint() { return null; },

  get applyDocumentStyleSheets() { return true; },

  
  
  runValidation : function( event )
  {
    var target = event.target;
    if( target )
    {
      validateField( target );
    }
  }

}


//----------------------------------------------------------------------
// WidgetFactory

function widgetFactory() { dump("creating widgetFactory\n"); }

widgetFactory.prototype = {
  createElement : function(tagname) {
    switch (tagname) {
      case "ssn":
        dump("XXX Creating ssn element");
        return new ssnElement();
        break;
    }
    throw Components.results.NS_ERROR_FAILURE;
  }
};

//----------------------------------------------------------------------
// Module definition

var module = {
  registerSelf: function (compMgr, fileSpec, location, type) {
    dump("registerSelf called on Widget module\n");
    compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
    compMgr.registerFactoryLocation(this.cid,
                                    "Widget XTF Factory",
                                    this.contractId,
                                    fileSpec,
                                    location,
                                    type );
  },
  
  getClassObject: function (compMgr, cid, iid) {
    if (!cid.equals(this.cid)) {
      throw Components.results.NS_ERROR_NO_INTERFACE;
    }
    
    if (!iid.equals(Components.interfaces.nsIFactory)) {
      throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
    }
    
    return this.factory;
  },
  
  /* CID for this class */
  cid: Components.ID("{0fc41cbc-043f-4a32-b570-8a7bb77d0ee9}"),
  
  /* Contract ID for this class */
  contractId: "@mozilla.org/xtf/element-factory;1?namespace=urn:mozilla:xtf:tests:ssn",
  
  /* factory object */
  factory: {
    createInstance: function (outer, iid) {
      if (outer != null)
        throw Components.results.NS_ERROR_NO_AGGREGATION;
      
      return new widgetFactory();
    }
  },
  
  canUnload: function(compMgr) {
    return true;
  }
};

// NSGetModule: Return the nsIModule object.
function NSGetModule(compMgr, fileSpec) {
  dump("NSGetModule called on widget module\n");
  return module;
}
